#!/usr/bin/env node

var fs = require('fs');
var ir = require('inquirer');
var ncp = require('ncp')
var exec = require('child_process').exec;
var schema = [{
  type: "input",
  name: "name",
  message: "请输入项目名称："
}];

function init() {
  ir.prompt(schema, function(result) {
    if (result.name) {
      fs.exists(result.name, function(dir) {
        check(dir, result)
      })
    } else {
      console.log('[!]项目名称不能为空')
      init()
    }

  });
}

function check(dir, result) {
  if (dir) {
    ir.prompt([{
      type: 'confirm',
      name: 'replace',
      message: result.name + '目录已经存在,是否覆盖？',
      default: true
    }], function(answer) {
      if (answer.replace) {
        make(result.name)
      } else {
        console.log('[!] 取消目录创建')
      }
    });
  } else {
    make(result.name)
  }
}

function make(name) {
  fs.mkdir(name, function() {
    console.log('[!] 开始初始化项目文件...')
    var dirname = __dirname.replace(/\\bin/, '')
    var reg = /\{\{title\}\}/;
    var files = fs.readdirSync(dirname + '/docs');
    files.forEach(function(filename) {
      var flg = fs.lstatSync(dirname + '/docs/' + filename).isDirectory();
      if (flg) {
        ncp(dirname + '/docs/' + filename, name + '/' + filename, {stopOnErr:true},function(err) {
          if (err) {
            return console.log(err)
          };
          console.log('[!] 创建' + '资源文件完成')
        })
      } else {
        fs.readFile(dirname + '/docs/' + filename, function(err, data) {
          var html = data.toString().replace(reg, name)
          if (!fs.existsSync(name + '/' + filename, html)) {
            fs.writeFile(name + '/' + filename, html, function(err) {
              console.log('[!] 创建' + filename + '文件完成')
            })
          } else {
            fs.unlink(name + '/' + filename, function() {
              fs.writeFile(name + '/' + filename, html, function(err) {
                console.log('[!] 创建' + filename + '文件完成')
              })
            })
          }
        })
      }
    })
  })
}

init()
